﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FTPClient
{
    public partial class Form1 : Form
    {
        FTPLibrary.FTPManager _fm = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (this._fm != null)
            {
                _fm.Dispose();
            }
        }

        private void btnFtp_Click(object sender, EventArgs e)
        {
            string serverAddress = this.txtServerAddress.Text;
            string userName = this.txtUserName.Text;
            string password = this.txtPassword.Text;

            try
            {
                if (serverAddress.Trim().Length == 0)
                {
                    throw new ApplicationException("FTPサーバーの情報が未入力です。");
                }
                if (userName.Trim().Length == 0)
                {
                    throw new ApplicationException("ユーザー名の情報が未入力です。");
                }

                this._fm = new FTPLibrary.FTPManager(serverAddress, userName, password);

                DispDirectoryInfo();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void DispDirectoryInfo()
        {
            int picIndex;

            this.listView1.Items.Clear();

            foreach (FTPLibrary.FTPManager.TargetInfo info in this._fm.DirectoryInfo)
            {
                picIndex = (int)info.TypeInfo;

                if (picIndex >= 0)
                {
                    this.listView1.Items.Add(new ListViewItem(info.Name, picIndex));
                }
            }

            this.lblCurrentDir.Text = this._fm.CurrentDirectory;
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            int selectedIndex = this.listView1.SelectedItems[0].Index;

            switch (this._fm.DirectoryInfo[selectedIndex].TypeInfo)
            {
                case FTPLibrary.FTPManager.ListType.Folder:
                case FTPLibrary.FTPManager.ListType.RootDir:
                    this._fm.ChangeDirectory(this.listView1.SelectedItems[0].Text);
                    DispDirectoryInfo();
                    break;
                case FTPLibrary.FTPManager.ListType.File:
                    this._fm.DownLoadFileAscii(this.listView1.SelectedItems[0].Text, Application.StartupPath + @"\" + this.listView1.SelectedItems[0].Text);
                    break;
                default:
                    break;
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (OpenFileDialog ofd = new OpenFileDialog())
            {
                ofd.ShowDialog();
                this._fm.UpLoadFileAscii(System.IO.Path.GetFileName(ofd.FileName), ofd.FileName);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this._fm.DeleteFile(this.listView1.SelectedItems[0].Text);
        }
    }
}
